# OPTION: perl integration (FC1+)
%define perl_integration	1
# OPTION: krb5 for Zephyr protocol (FC1+)
%define krb_integration		1
# OPTION: gtkspell integration (FC1+)
%define gtkspell_integration	1
# OPTION: Preferred Applications with gnome-open (FC1+)
%define gnome_open_integration	1
# OPTION: Evolution 1.5+ integration (FC3+)
%define evolution_integration	1
# OPTION: SILC integration (FC3+)
%define silc_integration	1
# OPTION: Mono integration (FC5+)
%define mono_integration	0
# OPTION: dbus integration (FC5+)
%define dbus_integration	1

# OPTION: Howl integration (seems broken)
%define howl_integration	0
# OPTION: gadugadu integration (not shipped in core)
%define gadugadu_integration	0
# OPTION: Meanwhile integration (not shipped in core)
%define meanwhile_integration	1

# Prerelease define
%define betaver	beta5

Name:		gaim-meanwhile
Version:	2.0.0
Release:	0.5.%{betaver}%{?dist}
License:	GPL
Group:		Applications/Internet
URL:		http://gaim.sourceforge.net/
Source0:	http://download.sourceforge.net/gaim/gaim-%{version}%{betaver}.tar.bz2
Epoch:		2

## Fedora gaim defaults - Please Regenerate for Each Major Release
# 1) run gaim as new user 2) edit preferences 3) close 4) copy .gaim/prefs.xml
# - enable System Tray Icon
# - enable ExtPlacement plugin
# - enable History plugin
# - enable Message Notification plugin
#   Insert count of new messages into window title
#   Set window manager "URGENT" hint
# - disable buddy icon in buddy list
# - enable Logging (in HTML)
# - Browser "GNOME Default"
# - Smiley Theme "Default"
Source1:	gaim-fedora-prefs.xml

## Patches 0-99: Fedora specific or upstream wont accept
# to be replaced by upstream fix
Patch5:		gaim2-PIE.patch

## Patches 100+: To be Included in Future Upstream
Patch102: gaim-2.0.0beta5-debian-02_gnthistory-in-gtk.patch
Patch103: gaim-2.0.0beta5-debian-03_gconf-gstreamer.patch
Patch104: gaim-2.0.0beta5-debian-04_blist-memleak.patch
Patch105: gaim-2.0.0beta5-debian-05_url-handler-xmpp.patch
Patch106: gaim-2.0.0beta5-debian-06_jabber-registration-srv.patch
Patch107: gaim-2.0.0beta5-debian-07_msn-custom-smiley-crash.patch

Patch150: gaim-2.0.0beta5-silc-edit-account-crash.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Summary:	A Gtk+ based multiprotocol instant messaging client

# Require Binary Compatible glib
# returns bogus value if glib2-devel is not installed in order for parsing to succeed
# bogus value wont make it into a real package
%define glib_ver %([ -a %{_libdir}/pkgconfig/glib-2.0.pc ] && pkg-config --modversion glib-2.0 | cut -d. -f 1,2 || echo -n "999")
BuildRequires:	glib2-devel
Requires:       glib2 >= %{glib_ver}

# Basic Library Requirements
BuildRequires:	libao-devel, startup-notification-devel, audiofile-devel
BuildRequires:  cyrus-sasl-devel
BuildRequires:	mozilla-nss-devel
BuildRequires:	gtk2-devel
BuildRequires:  gettext
BuildRequires:  libXScrnSaver-devel
BuildRequires:  intltool
BuildRequires:  desktop-file-utils

# krb5 needed for Zephyr (FC1+)
%if %{krb_integration}
BuildRequires:	krb5-devel
%endif
# gtkspell integration (FC1+)
%if %{gtkspell_integration}
BuildRequires:	gtkspell-devel, aspell-devel
%endif
# Preferred Applications (FC1+)
%if %{gnome_open_integration}
Requires:	libgnome
%else
Requires:	htmlview
%endif
# Evolution integration (FC3+)
%if %{evolution_integration}
BuildRequires:	evolution-data-server-devel
%endif
# SILC integration (FC3+)
%if %{silc_integration}
BuildRequires:	libsilc-devel
%endif
# Mono integration (FC5+)
%if %{mono_integration}
BuildRequires:	mono-devel
%endif
# DBus integration (FC5+)
%if %{dbus_integration}
BuildRequires:	dbus-devel >= 0.35
%endif

# Howl integration (seems to be broken)
%if %{howl_integration}
BuildRequires:	avahi-devel
%endif
# Meanwhile integration (not shipped in core)
%if %{meanwhile_integration}
BuildRequires:	meanwhile-devel
%endif
# Gadugadu integration (not shipped in core)
%if %{gadugadu_integration}
BuildRequires:	ekg-devel
%endif

%description
Gaim protocol library to use the meanwhile Lotus Sametime library

%prep
%setup -q -n gaim-%{version}%{betaver}
#%patch5 -p1
## Patches 100+: To be Included in Future Upstream
%patch102 -p0
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1

%patch150 -p1

# Relabel internal version for support purposes
sed -i "s/%{version}%{betaver}/%{version}-%{release}/g" configure
chmod 755 configure

# If not using gnome-open, then default to htmlview 
cp %{SOURCE1} prefs.xml
if [ "%{gnome_open_integration}" == "0" ]; then
	sed -i "s/gnome-open/custom/g" prefs.xml
	sed -i "s/pref name='command' type='string' value=''/pref name='command' type='string' value='htmlview'/" prefs.xml
fi




%build
%if %{krb_integration}
	WITH_KRB="--with-krb4"
%endif
%if %{silc_integration}
	WITH_SILC="--with-silc-includes=%{_includedir}/silc --with-silc-libs=%{_libdir}"
%endif
%if %{perl_integration}
	WITH_PERL="--enable-perl"
%else
	WITH_PERL="--disable-perl"
%endif
%if %{howl_integration}
	WITH_HOWL="--with-howl-includes=/usr/include/avahi-compat-howl/"
%endif
%if %{mono_integration}
	WITH_MONO="--enable-mono"
%else
	WITH_MONO="--disable-mono"
%endif
%if %{dbus_integration}
	WITH_DBUS="--enable-dbus"
%else
	WITH_DBUS="--disable-dbus"
%endif


# FC5+ automatic -fstack-protector-all switch
export RPM_OPT_FLAGS=${RPM_OPT_FLAGS//-fstack-protector/-fstack-protector-all}
export CFLAGS="$RPM_OPT_FLAGS"

# disable tcl and tk because nobody uses it
# gnutls is buggy so use mozilla-nss on all distributions
%configure --disable-tcl --disable-tk --enable-gnutls=no --enable-nss=yes \
           --enable-cyrus-sasl \
	   $WITH_KRB $WITH_SILC $WITH_PERL $WITH_HOWL $WITH_MONO \
	   $WITH_SASL $WITH_DBUS
# smp_mflags breaks the mono plugin
make


%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

# remove libtool libraries and static libraries
rm -f `find $RPM_BUILD_ROOT -name "*.la" -o -name "*.a"`
# remove the old perllocal.pod file
rm -f $RPM_BUILD_ROOT%{perl_archlib}/perllocal.pod
# remove relnot.so plugin since it is unusable for our package
rm -f $RPM_BUILD_ROOT%{_libdir}/gaim/relnot.so

# remove everything except the meanwhile parts
rm -rf $RPM_BUILD_ROOT%{_bindir}
rm -rf $RPM_BUILD_ROOT%{_includedir}
rm -rf $RPM_BUILD_ROOT%{_libdir}/libgaim*
rm -rf $RPM_BUILD_ROOT%{_libdir}/perl5
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig
rm -rf $RPM_BUILD_ROOT%{_libdir}/debug/usr/bin
rm -rf $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/perl5
rm -rf $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/libgaim*
rm -rf $RPM_BUILD_ROOT%{_datadir}
rm -rf $RPM_BUILD_ROOT%{_prefix}/src
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/gconf/schemas/gaim.schemas
rm -rf $RPM_BUILD_ROOT%{_libdir}/gaim/private

#preserve the libsametime debug libraries and delete the rest
#mv $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/gaim/libsametime.so.debug $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/gaim/sametime.tmp
#rm -rf $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/gaim/*.so
#mv $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/gaim/sametime.tmp $RPM_BUILD_ROOT%{_libdir}/debug/usr/lib/gaim/libsametime.so

# preserve the libsametime libraries and delete the rest
mv $RPM_BUILD_ROOT%{_libdir}/gaim/libsametime.so $RPM_BUILD_ROOT%{_libdir}/gaim/sametime.tmp
rm -rf $RPM_BUILD_ROOT%{_libdir}/gaim/*.so
mv $RPM_BUILD_ROOT%{_libdir}/gaim/sametime.tmp $RPM_BUILD_ROOT%{_libdir}/gaim/libsametime.so


%if %{perl_integration}
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type f -name '*.bs' -empty -exec rm -f {} ';'
%endif

# make sure that we can write to all the files we've installed
# so that they are properly stripped
chmod -R u+w $RPM_BUILD_ROOT/*

#%find_lang gaim


%post 
/sbin/ldconfig -n %{_libdir}/gaim
# This is a hack that we have to do. Mono apps need mono_exec_t. Since gaim doesn't 
# call /usr/bin/mono to run its mono bits, the existing selinux policy misses this.
#/usr/bin/chcon -t mono_exec_t /usr/bin/gaim 

# XXX: This line above fails on non-selinux systems with a non-zero return code.
# Changing the selinux context here would also cause rpm -V and TPS failure.
# Can't we find a better solution for this?

# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=196877
# There is also concern that we don't want gaim to run with this security context
# due to its historical security track record.  For now we are disaling mono
# temporarily until we decide a long term solution.

%postun
/sbin/ldconfig -n %{_libdir}/gaim

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_libdir}/gaim/

%changelog
* Sat Oct 28 2006 Josh Boyer <jwboyer@jdub.homelinux.org> 2.0.0-0.5.beta4
- Rebuild against most recent core package

* Sun Aug 27 2006 Josh Boyer <jwboyer@jdub.homelinux.org> 2.0.0-0.4.beta3
- Bump and rebuild for FE6

* Wed Jun 28 2006 Josh Boyer <jwboyer@jdub.homelinux.org> 2.0.0-0.3.beta3
- Temporarily build all of gaim and only install the libsametime.so library

* Wed Feb 15 2006 - jwboyer@jdub.homelinux.org 1.2.8-2
- Bump release for FE5 rebuild

* Mon Jan 23 2006 - jwboyer@jdub.homelinux.org 1.2.8-1
- Update to latest release
- Remove patches (in upstream)
- Fix typo in last changelog

* Fri Jan 13 2006 - jwboyer@jdub.homelinux.org 1.2.7-3
- Fix patches to have the correct strip level.  Gah.

* Fri Jan 13 2006 - jwboyer@jdub.homelinux.org 1.2.7-2
- Fix crash with empty chat title
- Fix crash with empty message in group chat

* Tue Jan 3 2006 - jwboyer@jdub.homelinux.org 1.2.7-1
- Update to latest release

* Thu Dec 15 2005 - jwboyer@jdub.homelinux.org 1.2.6-2
- Fix meanwhile requires

* Wed Dec 14 2005 - jwboyer@jdub.homelinux.org 1.2.6-1
- Update to latest release

* Sun Oct 30 2005 - jwboyer@jdub.homelinux.org 1.2.5-1
- Update to latest release

* Fri Sep 30 2005 - jwboyer@jdub.homelinux.org 1.2.4-3
- Add dependency on meanwhile < 0.5.0 to avoid upcomming API breakage

* Fri Jul 15 2005 - jwboyer@jdub.homelinux.org 1.2.4-2
- Bump release for rebuild

* Thu Jul 14 2005 - jwboyer@jdub.homelinux.org 1.2.4-1
- Update to latest upstream release
- Fixes bug 159942

* Tue Jul 12 2005 - jwboyer@jdub.homelinux.org 1.2.4-0.cvs
- Build test RPM

* Tue May 31 2005 - jwboyer@jdub.homelinux.org 1.2.3-1
- Update to latest version

* Tue May 24 2005 - jwboyer@jdub.homelinux.org 1.2.2-2
- Update from review comments

* Tue May 23 2005 - jwboyer@jdub.homelinux.org 1.2.2-1
- Initial package, adapted from spec file by Dag Wieers

